var player = {
    x: 0,
    y: 0,
    turn: 0, // adjust rotation
    rotation: 0, // current rotation
    rotRad: 2 * Math.PI / 180, // rotation steps
    direction: 0, // 1 forward, 0 still or -1 backwards
    speed: 2, // how far to move if direction !== 0
    radius: 15, // for collision detection
    mapRadius: 3, // draw radius on map
    weapons: null, // or wands and spells
    animate: function(){
        this.rotation += this.turn * this.rotRad; // new direction
        this.rotation = only360(this.rotation);
        let howFar = this.direction * this.speed; // move this far
        if(howFar){
            let newX = this.x + Math.cos(this.rotation) * howFar;
            let newY = this.y + Math.sin(this.rotation) * howFar;
            let pos = detectCollision3(this.x, this.y, newX, newY, this.radius, this.rotation, this.direction);
            this.x = pos.x;
            this.y = pos.y;    
        }
        // if(!Game.map.isWall(newx, newy)){
        //     this.x = newx;
        //     this.y = newy;
        // }
        Game.map.showPlayer(this);
    },
    createWeapons: function() {
        this.weapons = new Actor(0,0);
        let a = new AnimAudio("images/guna8x80x100.png", 8, 80, 100, false, 20, "audio/gun1.mp3");
        this.weapons.anims.push(a);
        a = new AnimAudio("images/gunb7x200x200.png", 8, 200, 200, false, 20, "audio/gun0.mp3");
        this.weapons.anims.push(a);
        this.weapons.display = function(ctx) {
            // inside function this => weapons object
            this.anims[this.current].animate(ctx, this.x, this.y);
        };
        this.weapons.change = function(to){
            this.resetCurrent(to);
            this.x = (Game.projectionWidth - this.width) / 2;
            this.y = Game.projectionHeight - this.height;    
        };
        this.weapons.deploy = function () {
            this.activate(true);
            for (let i = 0; i < sprites.length; i++) {
                if (sprites[i] instanceof NPC) {
                    if (sprites[i].state & NPC.states.seen) {
                        if (sprites[i].playerView.distance <= Game.gameScale * 2.5) {
                            let angle = only360(sprites[i].playerView.angle + Math.PI);
                            let hit = Math.abs(angle - player.rotation) <= 6 * Math.PI / 180;
                            if (hit) {
                                sprites[i].manageActions = NPC.passOn;
                            }
                        }
                    }
                }
            }
        };
        this.weapons.change(0);
    },
    changeWeapon: function(){
        let nextOne = this.weapons.current + 1;
        nextOne %= this.weapons.anims.length;
        this.weapons.change(nextOne);
    }
};